Vector Flow Tiles

Purpose

The Traffic API Vector Flow Tiles endpoint provides data on zoom levels ranging from 0 to 22.

  • For zoom level 0, the world is displayed on a single tile.
  • At zoom level 22, the world is divided into 244 tiles. See the Zoom Levels and Tile Grid .

The service delivers traffic flow data packaged in a vector representation of squared sections called vector tiles.

  • Each tile includes a pre-defined collection of road shapes with traffic flow data.
  • The format of the tile is formally described using the protobuf schema .

It can show both the current speed of traffic on different road segments, and the difference between current speed and the free-flow speed on the road segment.

Tiles resolution

Road geometry is stored as coordinates in the range of 0-4095. Coordinates (0,0) define the top-left corner of the tile.

Vector format

The Vector format is a binary format created by using Google Protocol Buffers to serialize the data according to this defined vector schema .

  • The data is mapped to a protobuf layer called “Traffic flow”.
  • Besides the protobuf layers, the protobuf tags are also used to further describe the traffic.
  • The protobuf tags are split into two categories: default and on-demand.
    • The default tags are used unless they are filtered out by the tags attribute.
    • The on-demand tags are used only if they were added by the tags attribute.
    • The on-demand tags marked as EXPLICIT must be added to tags list explicitly - they are not included automatically when using a wildcard.

Currently, the following Traffic flow tags are used.

Default tags

TagDescription

road_category
string

The tag value describes the road category.
Allowed values:

  • motorway
  • motorway_link
  • trunk
  • trunk_link
  • primary
  • primary_link
  • secondary
  • secondary_link
  • tertiary
  • tertiary_link
  • street
  • service
  • track

road_subcategory
string

The tag presence indicates if the road has a subcategory. Not all road categories have subcategories.
Allowed values:

  • For the street road category:

    • unclassified
    • residential
    • living_street
  • For the service road category:

    • parking
    • driveway
    • alley

relative_speed
double

The tag value indicates the speed relative to free-flow traffic.
Allowed values: Fractional value is 0.00 - 1.00

left_hand_traffic
boolean

The tag presence indicates if the road has left-hand traffic. If the tag is not present the road has right-hand traffic.
Allowed value: true

road_closure
boolean

The tag presence indicates if the road is closed to traffic. If the tag is not present the road is not closed and is passable.
Allowed value: true

display_class integer

The tag value represents the ranking of the road based on its importance and relevance. It can be used for filtering. Allowed values: positive integers

On-demand tags

TagDescription

absolute_speed
double

The tag value indicates the absolute speed in kmph (kilometers per hour).
Allowed values: Absolute value is greater than or equal to 0.

part_of_two_way_road
boolean

The tag presence indicates if the traffic is part of a two-way road (two different geometries, each with a value for one side). If the tag is not present, the flow covers the whole one-way road.
Allowed value: true

openlr
string
EXPLICIT

The OpenLR code describing the flow section.
Allowed value: text

Request data

HTTPS method: GET

  • Constants and parameters enclosed in curly brackets { } must be replaced with their values.
  • Please see the following Request parameters section with the required and optional parameters tables for their values. The generic request format is as follows.
get
URL request format
https://{baseURL}/maps/orbis/traffic/flow/vector/tile/{zoom}/{x}/{y}?apiVersion=2&key={Your_API_Key}
get
URL request example
https://api.tomtom.com/maps/orbis/traffic/flow/vector/tile/5/4/8?apiVersion=2&key={Your_API_Key}
get
curl command request example
curl 'https://api.tomtom.com/maps/orbis/traffic/flow/vector/tile/5/4/8?apiVersion=2' -H "TomTom-Api-Key: {Your_API_Key}"

Request parameters

These elements are used in calls to generate all vector tile layers.

  • Required parameters must be used or the call will fail.
  • Parameters and values are case-sensitive.
  • Optional parameters may be used.
Required parametersDescription

baseURL
string

The base URL for calling TomTom services.
Value: api.tomtom.com

zoom
integer

The zoom level of a tile to be rendered.
Value: 022

x
integer

The x coordinate of a tile on the zoom grid.
Value: 0…2zoom -1

y
integer

The y coordinate of a tile on the zoom grid.
Value: 0…2zoom -1

key
string

An API Key valid for the requested service.
Please note that using the TomTom-Api-Key header is recommended over the key query parameter for improved security.
Value: Your valid API Key.

Optional parametersDescription

apiVersion
integer

Contains a version of the API to call.
Value: The current version is 2.

attributes string

A list of selected fields to apply on response content, specified in dot-notation.
See the Attributes query parameter section for details and examples.
Value: list of the selected fields.

Request headers

Required headersDescription
TomTom-Api-Key

An API Key valid for the requested service.
Preferred method for authentication. Using the header is recommended over the key query parameter for improved security.
Value: Your valid API Key.

TomTom-Api-Version

Contains a version of the API to call.
Value: The current version is 2.

Optional headersDescription
Accept

Advertises which content types, expressed as MIME types, the client is able to understand. In this service, the header is used to specify a preferred response format. If the preferred format is not supported, the server will fall back to the default one.
Value: Accept: application/vnd.mapbox-vector-tile

Accept-Encoding

Contains the content encoding (usually a compression algorithm), that the client is able to understand.
Value: gzip

Attributes

A list of selected fields to apply on response content, specified in dot-notation.
See the Attributes header section for details and examples.
Value: list of the selected fields.

Attributes-Exclude

A list of selected fields to omit specific content added to the response, specified in dot-notation.
See the Attributes-Exclude header section for details and examples.
Value: list of the selected fields.

If-None-Match

Contains an identifier for a specific version of a resource. The server will send back the requested resource with a 200 HTTP status code, only if it doesn’t have an ETag matching the given one.
Value: string

Tracking-ID

Specifies an identifier for the request.

  • It can be used to trace a call.

  • The value must match the regular expression '^[a-zA-Z0-9-]{1,100}$'.

  • An example of the format that matches this regular expression is a UUID (e.g., 9ac68072-c7a4-11e8-a8d5-f2801f1b9fd1).

  • For details check RFC 4122 .

  • If specified, it is replicated in the Tracking-ID response header.

  • It is only meant to be used for support and does not involve tracking of you or your users in any form.

Value: string

Attributes

Attributes header

A list of selected fields to apply on response content, specified in dot-notation. Nested fields are expressed using . separators and optional grouped subfields using parentheses.
Attributes header must contain at least one valid top-level field. Using only a top-level * wildcard is not allowed.
When a field name refers to a non-primitive object, all its non-EXPLICIT subfields are returned by default unless further restricted in the header. EXPLICIT fields (as documented per API) are only returned when they are explicitly listed in Attributes (they are never included solely by selecting their parent or by using *).
The * wildcard may be used only at non–top-level positions to include all non-EXPLICIT subfields of the selected object.

Syntax:

  • <field-list> ::= <field> (',' <field>)*
  • <field> ::= <name> ('.' <field> | <field-set>)?
  • <field-set> ::= '(' <field-set-list> ')'
  • <field-set-list> ::= '*' (',' <field>)* | <field> (',' <field>)*
  • <name> ::= one or more alphabetic characters

Note:

  • All listed field names must exist in the attributes schema; unknown fields result in an error.
  • Attributes schema can be found there .
  • APIs may restrict which fields are allowed in Attributes. Disallowed-but-existing fields result in an error.
  • New fields may be added over time. When they are marked EXPLICIT, they are not returned unless explicitly requested via Attributes, preserving backward compatibility and performance.
  • If attributes query parameter is also supported by the endpoint - then it takes precedence over Attributes - Attributes-Exclude header pair.

Examples:

  • tags.road_category, tags.road_subcategory
  • tags(road_category, road_subcategory)
  • tags(road_category, road_subcategory), roadCategories(motorway)
  • roadCategories.*

Attributes-Exclude header

A list of selected fields to omit specific content added to the response, specified in dot-notation. Nested fields are expressed using . separators and optional grouped subfields using parentheses.
Any field listed in Attributes-Exclude, including its entire sub-tree, is omitted from the response, regardless of whether it was included implicitly or explicitly via the Attributes header. Exclusion always overrules inclusion.
The format of the field list is the same “listed dot-notation” used for the Attributes header:

Syntax:

  • <field-list> ::= <field> (',' <field>)*
  • <field> ::= <name> ('.' <field> | <field-set>)?
  • <field-set> ::= '(' <field-set-list> ')'
  • <field-set-list> ::= '*' (',' <field>)* | <field> (',' <field>)*
  • <name> ::= one or more alphabetic characters

Notes:

  • The exclusion list is applied to the result of the inclusion list. If a parent field is excluded, all of its children are excluded, even if some of those children were explicitly listed in Attributes.
  • When Attributes header inclusion list is not present in the request, then Attributes-Exclude header value is ignored.
  • Listed field names in Attributes-Exclude must exist in the attributes schema; unknown fields result in an error.
  • Attributes schema can be found there .
  • APIs may restrict which fields are allowed in Attributes-Exclude. Disallowed-but-existing fields result in an error.
  • Fields may occur multiple times in Attributes-Exclude (not recommended, but not an error).
  • Some overlap between Attributes and Attributes-Exclude is allowed. In case of overlap, the exclusion takes precedence.
  • Whether a field is EXPLICIT or not does not change the semantics of exclusion: if it is present in Attributes-Exclude, it is omitted whenever it would otherwise have been returned.
  • If all fields are excluded, then empty tile is returned.
  • If attributes query parameter is also supported by the endpoint - then it takes precedence over Attributes - Attributes-Exclude header pair.

Example:
Attributes: roadCategories.*
Attributes-Exclude: roadCategories.motorway_link
Results in all road categories being returned except for the motorway_link.

Attributes query parameter

A list of selected fields to apply on response content, specified in dot-notation. Nested fields are expressed using . separators and optional grouped subfields using parentheses.
attributes query parameter must contain at least one valid top-level field. Using only a top-level * wildcard is not allowed.
When a field name refers to a non-primitive object, all its non-EXPLICIT subfields are returned by default unless further restricted in the query parameter. EXPLICIT fields (as documented per API) are only returned when they are explicitly listed in attributes (they are never included solely by selecting their parent or by using *).
The * wildcard may be used only at non–top-level positions to include all non-EXPLICIT subfields of the selected object.

Syntax:

  • <field-list> ::= <field> (',' <field>)*
  • <field> ::= <name> ('.' <field> | <field-set>)?
  • <field-set> ::= '(' <field-set-list> ')'
  • <field-set-list> ::= '*' (',' <field>)* | <field> (',' <field>)*
  • <name> ::= one or more alphabetic characters

Note:

  • All listed field names must exist in the attributes schema; unknown fields result in an error.
  • Attributes schema can be found there .
  • APIs may restrict which fields are allowed in attributes. Disallowed-but-existing fields result in an error.
  • New fields may be added over time. When they are marked EXPLICIT, they are not returned unless explicitly requested via attributes, preserving backward compatibility and performance.
  • The attributes query parameter takes precedence over Attributes - Attributes-Exclude header pair.

Examples:

  • tags.road_category,tags.road_subcategory
  • tags(road_category,road_subcategory)
  • tags(road_category,road_subcategory),roadCategories(motorway)
  • roadCategories.*

Attributes schema

AttributeDescription

tags

The list of the values representing the available tags in the tile.
Default value: road_category,road_subcategory,relative_speed,left_hand_traffic,road_closure,display_class
Allowed values:

  • road_category
  • road_subcategory
  • left_hand_traffic
  • road_closure
  • relative_speed
  • absolute_speed
  • part_of_two_way_road
  • openlr
  • display_class

By default, only the default tags are attached to the tile geometry. See Vector format for details.

  • The attribute behaves as a filter, narrowing down the list of tags enclosed in each tile.
  • The fewer tags chosen, the smaller the tile size because of better geometry merging.

roadCategories

This attribute allows the choice of types of road categories to be included in the response. The attribute narrows down the road categories available at a particular zoom level. Default value: all road categories
Allowed values:

  • motorway
  • motorway_link
  • trunk
  • trunk_link
  • primary
  • primary_link
  • secondary
  • secondary_link
  • tertiary
  • tertiary_link
  • street
  • service
  • track

Response data

Successful response

The Traffic Vector Flow Tiles API endpoint, for a single request, returns a binary response body which must be deserialized by client code generated by the Google Protocol Buffers compiler.

The following examples use a simple textual representation of the serialized binary vector tile data to illustrate the response content.

get
Request example
https://api.tomtom.com/maps/orbis/traffic/flow/vector/tile/17/64989/42178?apiVersion=2&key={Your_API_Key}
Response example
layer: 0
name: Traffic flow
version: 2
extent: 4096
feature: 0
id: (none)
geomtype: linestring
geometry:
LINESTRING[count=3](3002 -409,2964 1292,2842 2382)
LINESTRING[count=3](2842 2382,2964 1292,3002 -409)
properties:
road_category="primary" [string]
relative_speed=0 [double]
left_hand_traffic=1 [bool]
feature: 1
id: (none)
geomtype: linestring
geometry:
LINESTRING[count=8](-409 656,-108 810,1260 1620,1832 1914,2842 2382,3792 2644,4400 2770,4505 2783)
properties:
road_category="primary" [string]
relative_speed=0.7 [double]
left_hand_traffic=1 [bool]
feature: 2
id: (none)
geomtype: linestring
geometry:
LINESTRING[count=10](4505 2766,4418 2752,3882 2660,3406 2552,2920 2430,2700 2308,2276 2114,1952 1958,940 1430,-409 648)
properties:
road_category="secondary" [string]
relative_speed=0.77 [double]
left_hand_traffic=1 [bool]
feature: 3
id: (none)
geomtype: linestring
geometry:
LINESTRING[count=7](2842 2382,2806 2752,2826 2932,3062 3494,3528 3882,4122 4366,4222 4505)
LINESTRING[count=7](4222 4505,4122 4366,3528 3882,3062 3494,2826 2932,2806 2752,2842 2382)
properties:
road_category="primary" [string]
relative_speed=1 [double]
left_hand_traffic=1 [bool]

Error response

The Traffic Vector Flow Tiles API endpoint for an invalid single request returns a response body in JSON format.

Error response field structure

FieldDescription

detailedError
object

Main object of the error response.

code
string

One of a server-defined set of error codes.

message
string

A human-readable description of the error code.
Error response example - JSON
{
"detailedError": {
"code": "INVALID_REQUEST",
"message": "Invalid zoom value. Allowed values are <0,22>."
}
}

Response codes

CodeMeaning & possible causes
200

OK

400

Bad request:

  • The combination of layer, type, and query parameters is not supported.

  • zoom n is out of range [0,22]: The requested zoom level is out of the possible range.

  • x n is out of range [0,2zoom -1]: The requested x coordinate is out of the possible range.

  • y n is out of range [0,2zoom-1]: The requested y coordinate is out of the possible range.

403

Forbidden: The supplied API Key is not valid for this request.

405

Method Not Allowed: The provided HTTP request method is known by the server, but is not supported by the target resource.

429

Too Many Requests: Too many requests were sent in a given amount of time for the supplied API Key.

500

Internal Server Error: There is a problem with the TomTom Traffic Vector Flow Tiles API endpoint.

503

Service currently unavailable

596

Service Not Found: Unknown version of the service.

Response headers

The following table lists HTTP response headers of particular interest to clients of the Traffic API Vector Flow Tiles endpoint.

HeaderDescription
Access-Control-Allow-Origin

Indicates that cross-origin resource sharing (CORS) is allowed.
Value: * universal.

Allow

Lists the set of supported HTTP methods. The header is sent in case a 405 HTTP response code is returned.
Value: GET, HEAD

Cache-Control

Contains directives for a caching mechanism.

Value: max-age=<number>

Content-Encoding

Indicates which encodings were applied to the response body.
Value: gzip

Content-Length

Contains information about the size of the response body.
Value: decimal number

Content-Type

Indicates the media type of the resource returned.
Value: application/vnd.mapbox-vector-tile

Date

Contains the date and time when the message was originated.
Value: http-date

ETag

Contains an identifier for a specific version of resource.
Value: W/"2fdbd61f30456"

Tracking-ID

An identifier for the request. If the Tracking-ID header was specified in the request, it is replicated in the response. Otherwise, it is generated automatically by the service. For details check RFC 4122 . It is only meant to be used for support and does not involve tracking of you or your users in any form.
Value: string